# Debugger Ghidra Class

This is the courseware for the Debugger training class.
It is meant to be viewed directly in GitHub or GitLab but can also be rendered for offline viewing in a classroom.
The courseware was developed with Linux user-space targets in mind, but many of the concepts and information apply to the other platforms.
There are differences in getting started, some subtleties in target behavior, and of course different instruction set architectures, but for the most part, the user interface is the same across the platforms.

## Table of Contents

### Beginner Material

1. [Getting Started](A1-GettingStarted.md)
1. [A Tour of the UI](A2-UITour.md)
1. [Breakpoints](A3-Breakpoints.md)
1. [Machine State: Memory, Registers, and Variables](A4-MachineState.md)
1. [Navigation](A5-Navigation.md)
1. [Memory Map](A6-MemoryMap.md)

### Advanced Material

1. [Remote Targets](B1-RemoteTargets.md)
1. [Emulation](B2-Emulation.md)
1. [Scripting](B3-Scripting.md)
1. [Modeling](B4-Modeling.md)
